<template>
  <a-page-header :title="getPageTitle()" @back="() => $router.go(-1)">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="id"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'name'">
              <a-tag color="orange">{{ record.name }}</a-tag>
            </template>
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <ShopStoreEdit v-model:visible="showEdit" :data="current" @done="reload" />
  </a-page-header>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import {getPageTitle} from '@/utils/common';
  import ShopStoreEdit from './components/shopStoreEdit.vue';
  import { pageShopStore, removeShopStore, removeBatchShopStore } from '@/api/shop/shopStore';
  import type { ShopStore, ShopStoreParam } from '@/api/shop/shopStore/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<ShopStore[]>([]);
  // 当前编辑数据
  const current = ref<ShopStore | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageShopStore({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 完整的列配置（包含所有字段）
  const columns = ref<ColumnItem[]>([
    {
      title: '网点ID',
      dataIndex: 'id',
      key: 'id',
      width: 90
    },
    {
      title: '网点名称',
      dataIndex: 'name',
      key: 'name'
    },
    // {
    //   title: '手机号码',
    //   dataIndex: 'phone',
    //   key: 'phone',
    //   ellipsis: true
    // },
    {
      title: '联系人',
      dataIndex: 'managerName',
      key: 'managerName'
    },
    {
      title: '所在省份',
      dataIndex: 'province',
      key: 'province'
    },
    {
      title: '所在城市',
      dataIndex: 'city',
      key: 'city'
    },
    {
      title: '所在辖区',
      dataIndex: 'region',
      key: 'region'
    },
    {
      title: '门店地址',
      dataIndex: 'address',
      key: 'address'
    },
    // {
    //   title: '经度',
    //   dataIndex: 'lng',
    //   key: 'lng',
    //   ellipsis: true
    // },
    // {
    //   title: '纬度',
    //   dataIndex: 'lat',
    //   key: 'lat',
    //   ellipsis: true
    // },
    // {
    //   title: '门店备注',
    //   dataIndex: 'comments',
    //   key: 'comments',
    //   ellipsis: true
    // },
    {
      title: '排序号',
      dataIndex: 'sortNumber',
      key: 'sortNumber',
      align: 'center',
      width: 90
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      width: 200,
      align: 'center',
      sorter: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: ShopStoreParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: ShopStore) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: ShopStore) => {
    const hide = message.loading('请求中..', 0);
    removeShopStore(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchShopStore(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: ShopStore) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'ShopStore'
  };
</script>

<style lang="less" scoped></style>
